:orphan:

.. _how-to:

How-to guides
================

Core pytest functionality
-------------------------

.. toctree::
   :maxdepth: 1

   usage
   assert
   fixtures
   mark
   parametrize
   tmp_path
   monkeypatch
   doctest
   cache

Test output and outcomes
----------------------------

.. toctree::
   :maxdepth: 1

   failures
   output
   logging
   capture-stdout-stderr
   capture-warnings
   skipping

Plugins
----------------------------

.. toctree::
   :maxdepth: 1

   plugins
   writing_plugins
   writing_hook_functions

pytest and other test systems
-----------------------------

.. toctree::
   :maxdepth: 1

   existingtestsuite
   unittest
   nose
   xunit_setup

pytest development environment
------------------------------

.. toctree::
   :maxdepth: 1

   bash-completion
